/* GCC */
#include<bits/stdc++.h>

using namespace std;

bool group[2][21], used[21][21][21][21];
int fn[21][21][21][21];

int solve(int l1, int r1, int l2, int r2) {
    if(r1 < l1 || r2 < l2)
        return 0;
    if(used[l1][r1][l2][r2])
        return fn[l1][r1][l2][r2];
    used[l1][r1][l2][r2] = true;
    vector<bool> was;
    int cur;
    for(int i = l1;i <= r1;++i)
    for(int j = l2;j <= r2;++j) {
        if(group[0][i] != group[1][j])
            continue;
        cur = solve(l1, i-1, l2, j-1) ^ solve(i+1, r1, j+1, r2);
        if(cur >= was.size())
            was.resize(cur+1, false);
        was[cur] = true;
    }
    for(int i = 0;i < was.size();++i)
    if(!was[i])
        return fn[l1][r1][l2][r2] = i;
    return fn[l1][r1][l2][r2] = was.size();
}

int main() {
    freopen("game.in", "r", stdin);
    freopen("game.out", "w", stdout);

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;

    for(int i = 0;i < n;++i)
        cin >> group[0][i];
    for(int i = 0;i < m;++i)
        cin >> group[1][i];

    if(!solve(0, n-1, 0, m-1))
        cout << "LOSE\n";
    else {
        cout << "WIN\n";
        int cur;
        for(int i = 0;i < n;++i)
        for(int j = 0;j < m;++j) {
            if(group[0][i] != group[1][j])
                continue;
            cur = solve(0, i-1, 0, j-1) ^ solve(i+1, n-1, j+1, m-1);
            if(cur == 0)
                cout << i << ' ' << j << '\n';
        }
    }
    return 0;
}
