/* GCC */
#include<bits/stdc++.h>

using namespace std;

typedef vector<int> big;

const int base = 10000;
bool used[102];
int arr[102], cnt[102];

big operator *(big a, int b) {
    int saved = 0;
    for(int i = 0;i < a.size() || saved;++i) {
        if(i == a.size())
            a.push_back(0);
        saved += a[i] * b;
        a[i] = saved % base;
        saved /= base;
    }
    while(a.size() > 1 && a.back() == 0) a.pop_back();
    return a;
}

big operator + (big a, big b) {
    int saved = 0;
    for(int i = 0;i < b.size() || saved;++i) {
        if(i == a.size())
            a.push_back(0);
        saved += a[i];
        if(i < b.size())
            saved += b[i];
        a[i] = saved % base;
        saved /= base;
    }
    while(a.size() > 1 && a.back() == 0) a.pop_back();
    return a;
}

big operator * (big a, big b) {
    big res = big(1, 0), hv, cur;
    for(int i = 0;i < b.size();++i) {
        hv = a * b[i];
        cur.assign(i, 0);
        for(int j = 0;j < hv.size();++j)
            cur.push_back(hv[j]);
        res = res + cur;
    }
    while(res.size() > 1 && res.back() == 0) res.pop_back();
    return res;
}

big big_pow(int a, int b) {
    big res = big(1, 1);
    for(int i = 0;i < b;++i)
        res = res * a;
    return res;
}

bool saved[102][102];
big saved_cnk[102][102];

big cnk(int n, int k) {
    if(k < 0 || k > n)
        return big(1, 0);
    if(k == n || k == 0)
        return big(1, 1);
    if(saved[n][k])
        return saved_cnk[n][k];
    saved[n][k] = true;
    return saved_cnk[n][k] = cnk(n-1, k-1) + cnk(n-1, k);
}

big factor(int n) {
    big res = big(1, 1);
    for(int i = 3;i <= n;i += 2)
        res = res * i;
    return res;
}
int main() {
    freopen("sleep2.in", "r", stdin);
    freopen("sleep2.out", "w", stdout);

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    for(int i = 0;i < n;++i) {
        cin >> arr[i];
        arr[i]--;
    }

    int len;
    for(int i = 0;i < n;++i) {
        if(used[i])
            continue;
        len = 0;
        while(!used[i]) {
            used[i] = true;
            len++;
            i = arr[i];
        }
        cnt[len]++;
    }

    for(int i = 2;i <= n;i += 2)
        if(cnt[i] & 1) {
            cout << "0\n";
            return 0;
        }
    big ans = big(1, 1), cur;
    for(int i = 1;i <= n;++i) {
        if(i & 1) {
            cur = big(1, 1);
            for(int j = 1;j <= cnt[i]>>1;j++)
                cur = cur + cnk(cnt[i], j<<1) * factor((j << 1) - 1) * big_pow(i, j);
        }
        else
            cur = factor(cnt[i] - 1) * big_pow(i, cnt[i]>>1);
        ans = ans * cur;
    }
    cout << ans.back();
    if(ans.size() > 1)
    for(int i = ans.size()-2;i >= 0;--i)
        cout << setw(4) << setfill('0') << ans[i];
    cout << "\n";
    return 0;
}
