/*GCC*/
#include <bits/stdc++.h>

using namespace std;

const int base = 10000;

typedef vector<int>big;

big operator*(big a,long long b){
    long long carry = 0;
    for(int i = 0;i < a.size() || carry;i++){
        if(i == a.size())
            a.push_back(0);
        carry += a[i] * b;
        a[i] = carry % base;
        carry /= base;
    }
    while(a.size() > 1 && a.back() == 0)
        a.pop_back();
    return a;
}

big operator*(big a,big b){
    big c(1,0);
    for(int i = 0;i < b.size();i++){
        big temp = a * b[i];
        long long carry = 0;
        for(int j = i;j < i+temp.size() || carry;j++){
            if(j == c.size())
                c.push_back(0);
            carry += c[j];
            if(j - i < temp.size())
                carry += temp[j-i];
            c[j] = carry % base;
            carry /= base;
        }
    }
    while(c.size() > 1 && c.back() == 0)
        c.pop_back();
    return c;
}

big operator+(big a,big b){
    long long carry = 0;
    for(int i = 0;i < b.size() || carry;i++){
        if(i == a.size())
            a.push_back(0);
        carry += a[i];
        if(i < b.size())
            carry += b[i];
        a[i] = carry % base;
        carry /= base;
    }
    while(a.size() > 1 && a.back() == 0)
        a.pop_back();
    return a;
}

big Cnk[101][101];

big C(int n,int k){
    if(!Cnk[n][k].empty())
        return Cnk[n][k];
    if(n == k || k == 0)
        Cnk[n][k] = big(1,1);
    else
        Cnk[n][k] = C(n-1,k-1) + C(n-1,k);
    return Cnk[n][k];
}

big df(int to){
    big res(1,1);
    for(int i = 3;i <= to;i += 2)
        res = res * i;
    return res;
}

big pw(int a,int b){
    if(b == 1)
        return big(1,a);
    big temp = pw(a,b/2);
    temp = temp * temp;
    if(b % 2 == 0)
        return temp;
    return temp * a;
}

int n;
vector<int>v,cnt;
vector<bool>u;

int main()
{
    // test big ar
    freopen("sleep2.in","r",stdin);
    freopen("sleep2.out","w",stdout);
    /////////////////////
    /////////////////////
    scanf("%d",&n);
    v.resize(n);
    u.assign(n,0);
    cnt.resize(n+1);
    for(int i = 0;i < n;i++){
        scanf("%d",&v[i]);
        --v[i];
    }
    for(int i = 0;i < n;i++){
        if(u[i])
            continue;
        int cur = i,len = 0;
        while(!u[cur]){
            u[cur] = 1;
            ++len;
            cur = v[cur];
        }
        ++cnt[len];
    }
    for(int i = 2;i <= n;i += 2){
        if(cnt[i] % 2 != 0){
            cout << 0 << '\n';
            return 0;
        }
    }
    big ans(1,1);
    for(int i = 2;i <= n;i += 2){
        if(!cnt[i])
            continue;
        ans = ans * pw(i,cnt[i]/2) * df(cnt[i]-1);
    }
    for(int i = 1;i <= n;i += 2){
        if(!cnt[i])
            continue;
        big temp(1,1);
        for(int j = 1;j <= cnt[i]/2;j++){
            temp = temp + C(cnt[i],2*j) * pw(i,j) * df(2*j - 1);
        }
        ans = ans * temp;
    }
    printf("%d",ans.back());
    for(int i = ans.size() - 2;i >= 0;i--)
        printf("%04d",ans[i]);
    printf("\n");
    return 0;
}
