/* GCC */
#include <bits/stdc++.h>

using namespace std;

int m, n;
int a[24];
int b[24];

char sg[24][24][24][24];

int main(){
	freopen("game.in", "r", stdin);
	freopen("game.out", "w", stdout);
    scanf("%d%d", &m, &n);
    for(int i = 0; i < m; i++){
        scanf("%d", &a[i]);
    }
    for(int i = 0; i < n; i++){
        scanf("%d", &b[i]);
    }
    for (int di = 0; di <= m; di++){
        for (int i = 0; i < m; i++){
            int i1 = i+di;
            if (i1 > m) break;
            for (int dj = 0; dj <= n; dj++){
                for (int j = 0; j < n; j++){
                    int j1 = j+dj;
                    if (j1 > n) break;
                    bool reached[24];
                    memset(reached, false, sizeof(reached));
                    for (int i2 = i; i2 < i1; i2++){
                        for (int j2 = j; j2 < j1; j2++){
                            if (a[i2] == b[j2]){
                                char up_code = sg[i][i2][j][j2];
                                char down_code = sg[i2+1][i1][j2+1][j1];
                                char code = up_code^down_code;
                                reached[code] = true;
                            }
                        }
                    }
                    for (char code = 0; code < 24; code++){
                        if (!reached[code]){
                            sg[i][i1][j][j1] = code;
                            break;
                        }
                    }
                }
            }
        }
    }

    if (!sg[0][m][0][n]){
        printf("LOSE\n");
    } else {
        printf("WIN\n");
        for (int i = 0; i < m; i++){
            for (int j = 0; j < n; j++){
                if (a[i] == b[j]){
                    char up_code = sg[0][i][0][j];
                    char down_code = sg[i+1][m][j+1][n];
                    char code = up_code^down_code;
                    if (code == 0){
                        printf("%d %d\n", i, j);
                    }
                }
            }
        }
    }
    return 0;
}































