/* GCC */
#include <bits/stdc++.h>

using namespace std;
#define big vector<int>
void norm(big &a)
{
    for(int i = 0; i<a.size(); i++)
    {
        if(a[i] > 9)
        {
            if(i + 1 == a.size())
            {
                a.push_back(0);
            }
            a[i + 1] += a[i] / 10;
            a[i] %= 10;
        }
    }
    for(;a.size() > 1 && !a.back();a.pop_back());
}
void show(const big a)
{
    for(int i = (int)a.size() - 1; i>=0; i--)
        printf("%d", a[i]);
    printf("\n");
}
//checked
big operator+(const big &a, const big &b)
{
    big c(max(a.size(), b.size()), 0);
    for(int i = 0; i<max(a.size(), b.size()); i++)
    {
        if(i < a.size()) c[i]+=a[i];
        if(i < b.size()) c[i]+=b[i];
    }
    norm(c);
    return c;
}
//checked
big operator*(const big &a, const big &b)
{
    big c(a.size()+b.size(), 0);
    for(int i =0; i<a.size(); i++)
    {
        for(int j =0; j<b.size(); j++)
        {
            c[i + j] += a[i] * b[j];
        }
    }
    norm(c);
    return c;
}
//checked
big Cnk[101][101];
big& C(int n, int k)
{
    if(Cnk[n][k].empty())
    {
        if(n == k || !k)
            Cnk[n][k].assign(1, 1);
        else
            Cnk[n][k] = C(n-1,k-1)+C(n - 1, k);
    }
    return Cnk[n][k];
}
vector<big> f(1, big(1, 1));
big& F(int n)
{
    n/=2;
    if(n>=f.size())
    {
        for(int i = f.size(); i<=n; i++)
        {
            f.push_back(f.back());
            for(int j =0; j<f.back().size(); j++)
                f.back()[j] *= 2 *i + 1;
            norm(f.back());
        }
    }
    return f[n];
}
big Pow(int a, int n)
{
    big A(1, 1);
    big B(1, a);
    norm(B);
    while(n > 0)
    {
        if(n&1)
        {
            A = A *B;
            B= B*B;
        }
        else
        {
            B= B*B;
        }
        n/=2;
    }
    return A;
}
//checked
vector<int> perm, cycle;
void read()
{
    int n, p;
    scanf("%d", &n);
    for(int i =0; i<n; i++)
    {
        scanf("%d", &p);
        perm.push_back(p - 1);
    }

}
void calc()
{
    cycle.assign(perm.size() + 1, 0);
    for(int i = 0; i<perm.size(); i++)
    {
        if(perm[i] >= 0)
        {
            int j = i;
            int c =0;
            while(perm[j] >= 0)
            {
                c++;
                int k = perm[j];
                perm[j] = -1;
                j = k;
            }
            cycle[c]++;
        }
    }
}
big solve()
{
    big ans(1, 1);
    for(int i =1; i<cycle.size(); i++)
    {
        if(cycle[i] > 0)
        {
            big tmp(1, 1);
            if(i & 1)
            {
                for(int j =1; j * 2 <= cycle[i]; j++)
                    {
                        tmp = tmp+Pow(i, j) *C(cycle[i], 2 * j) * F(2*j-1);
                    }
            }
            else
            {
                tmp = (cycle[i] & 1) ? big(1, 0) : Pow(i, cycle[i]/2) * F(cycle[i] - 1);
            }
            ans = ans * tmp;
        }
    }
    return ans;
}
int main()
{
//    for(int i =0; i<5; i++)
//        for(int j = 0; j<5; j++)
//    {
//        big a(1, i);
//        norm(a);
//        big b(1, j);
//        norm(b);
//        show(a);
//        printf(" + \n");
//        show(b);
//        printf(" = \n");
//        show(a + b);
//        printf("\n");
//        show(a);
//        printf(" * \n");
//        show(b);
//        printf(" = \n");
//        show(a * b);
//        printf("\n");
//        show(a);
//        printf(" ^ \n");
//        show(b);
//        printf(" = \n");
//        show(Pow(i, j));
//        printf("\n");
//    }
	freopen("sleep2.in", "r", stdin);
	freopen("sleep2.out", "w", stdout);
    read();
    calc();
    show(solve());
    return 0;
}
