#include<iostream>
#include<cstdio>

using namespace std;

const int N = 20+1;

int n, m;
int a[N], b[N];

int id[N][N][N][N];
inline int solve(int from_i, int to_i, int from_j, int to_j){
    if(from_i > to_i || from_j > to_j)
        return 0;
    if(id[from_i][to_i][from_j][to_j] != -1)
        return id[from_i][to_i][from_j][to_j];
    bool mex[N];
    for(int i = 0; i < N; ++i)
        mex[i] = false;
    for(int i = from_i; i <= to_i; ++i)
        for(int j = from_j; j <= to_j; ++j)
            if(a[i] == b[j])
                mex[solve(from_i, i-1, from_j, j-1)^solve(i+1, to_i, j+1, to_j)] = true;
    for(int i = 0; i < N; ++i)
        if(!mex[i])
            return id[from_i][to_i][from_j][to_j] = i;
}

int main(){
    freopen("game.in", "r", stdin);
    freopen("game.out", "w", stdout);
    scanf("%d%d", &n, &m);
    for(int i = 0; i < n; ++i)
        for(int j = 0; j < n; ++j)
            for(int k = 0; k < m; ++k)
                for(int l = 0; l < m; ++l)
                    id[i][j][k][l] = -1;
    for(int i = 0; i < n; ++i)
        scanf("%d", &a[i]);
    for(int i = 0; i < m; ++i)
        scanf("%d", &b[i]);
    int ans = solve(0, n-1, 0, m-1);
    if(ans == 0){
        printf("LOSE\n");
        return 0;
    }
    printf("WIN\n");
    for(int i = 0; i < n; ++i)
        for(int j = 0; j < m; ++j)
            if(a[i] == b[j] && (solve(0, i-1, 0, j-1)^solve(i+1, n-1, j+1, m-1)) == 0)
                printf("%d %d\n", i, j);
}
