#include <bits/stdc++.h>

using namespace std;
typedef vector<int> bignumber;

void Norm(bignumber& a){
    int i = 0;
    while(i < a.size()){
        if(a[i] > 9){
            if(i+1 == a.size())
                a.push_back(0);
            a[i+1] += a[i]/10;
            a[i] %= 10;
        }
        i++;
    }
    while(a.size() > 1 && a.back() == 0)
        a.pop_back();
}
bignumber operator+(const bignumber& a,const bignumber& b){
    bignumber c(max(a.size(),b.size()),0);
    for(int i = 0;i<a.size() || i<b.size();i++){
        if(i<a.size()) c[i] += a[i];
        if(i<b.size()) c[i] += b[i];
    }
    Norm(c);
    return c;
}
bignumber operator*(const bignumber& a,const bignumber& b){
    bignumber c(a.size()+b.size(),0);
    for(int i = 0;i<a.size();i++){
        for(int j = 0;j<b.size();j++)
            c[i+j] += a[i]*b[j];
    }
    Norm(c);
    return c;
}
bignumber Cnk[101][101];

bignumber C(int n,int k){
    if(Cnk[n][k].empty()){
        if(n == k || !k)
            Cnk[n][k].assign(1,1);
        else
            Cnk[n][k] = C(n-1,k-1) + C(n-1,k);
    }
    return Cnk[n][k];
}
vector<bignumber> F(1,bignumber(1,1));

bignumber& Fnn(int n){
    n /= 2;
    if(n >= F.size()){
        for(int i = F.size();i<=n;i++){
            F.push_back(F.back());
            for(int z = 0;z<F.back().size();z++){
                F.back()[z] *= 2*i+1;
            }
            Norm(F.back());
        }
    }
    return F[n];
}

vector<int> cicles_count;
vector<int> permutations;

void ReadData(){
    freopen("sleep2.in","r",stdin);
    int N,p;
    scanf("%d",&N);
    for(int i = 0;i<N;i++){
        scanf("%d",&p);
        permutations.push_back(p-1);
    }
}
void GetNumberOfCicles(){
    cicles_count.assign(permutations.size()+1,0);
    for(int i = 0;i<permutations.size();i++){
        if(permutations[i] >= 0){
            int c = 0;
            int j = i;
            while(permutations[j] >= 0){
                c++;
                int k = permutations[j];
                permutations[j] = -1;
                j = k;
            }
            cicles_count[c]++;
        }
    }
}
void FileOut(const bignumber& a){
    freopen("sleep2.out","w",stdout);
    for(int i = a.size()-1;i >= 0;i--)
        printf("%d",a[i]);
    cout << endl;
}
bignumber Pow(int a,int n){
    bignumber A(1,1);
    bignumber B(1,a);
    Norm(B);
    while(n){
        if(n&1){
            A = A*B;
            B = B*B;
        }
        else
            B = B*B;
        n /= 2;
    }
    return A;
}
bignumber GetAns(){
    bignumber ans(1,1);
    for(int i = 1;i<cicles_count.size();i++){
        if(cicles_count[i] > 0){
            bignumber tmp(1,1);
            if(i&1){
                for(int z = 1;z*2 <= cicles_count[i];z++){
                    tmp = tmp+C(cicles_count[i],2*z) * Fnn(2*z-1) * Pow(i,z);
                }
            }
            else
                tmp = (cicles_count[i]&1) ? bignumber(1,0) : Fnn(cicles_count[i]-1) * Pow(i,cicles_count[i]/2);
            ans = ans*tmp;
        }
    }
    return ans;
}
int main(){
    ReadData();
    GetNumberOfCicles();
    FileOut(GetAns());
}
