/* GCC */
#include <iostream>
#include <stdio.h>
#include <fstream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string.h>

using namespace std;

int m, n;
int A[25], B[25];
int P[25][25][25][25];
bool TF[404];

void F(int a, int b, int c, int d)
{
    memset(TF, 0, sizeof(TF));
    int x, y;
    for (int i=a; i<=b; i++)
        for (int j=c; j<=d; j++) if (A[i] == B[j]){
            if ((i == a) || (j == c)) x = 0; else x = P[  a][i-1][  c][j-1];
            if ((i == b) || (j == d)) y = 0; else y = P[i+1][  b][j+1][  d];
            TF[x^y] = true;
        }

    x = 0;
    while (TF[x]) x++;
    P[a][b][c][d] = x;
}

int main(void)
{
    freopen("game.in", "r", stdin);
    freopen("game.out", "w", stdout);

    scanf("%d%d", &m, &n);
    for (int i=0; i<m; i++) scanf("%d", &A[i]);
    for (int i=0; i<n; i++) scanf("%d", &B[i]);

    memset(P, 0, sizeof(P));
    for (int i=0; i<m; i++)
        for (int i1=0; i1+i<m; i1++)
            for (int j=0; j<n; j++)
                for (int j1=0; j1+j<n; j1++)
                    if ((i == 0) ||
                        (j == 0) ||
                        (i1+i == m-1) ||
                        (j1+j == n-1) ||
                        (A[i1-1] == B[j1-1]) ||
                        (A[i1+i+1] == B[j1+i+1])) F(i1, i1+i, j1, j1+j);

    if ((P[0][m-1][0][n-1] == 0) || (n*m == 0)) { printf("LOSE\n"); return 0; }
    printf("WIN\n");

    int x, y;
    for (int i=0; i<=m-1; i++)
        for (int j=0; j<=n-1; j++) if (A[i] == B[j]){
            if ((i ==   0) || (j ==   0)) x = 0; else x = P[  0][i-1][  0][j-1];
            if ((i == m-1) || (j == n-1)) y = 0; else y = P[i+1][m-1][j+1][n-1];
            if (x^y == 0) printf("%d %d\n", i, j);
       }

    fclose(stdin);
    fclose(stdout);

    return 0;
}
